cap program drop split_regs
program split_regs, eclass //slit estimates up so they can be displayed in columns: http://fmwww.bc.edu/RePEc/bocode/e/estout.old/advanced.html#advanced907
	syntax, estimate(string)
	est restore `estimate'
	qui esttab `estimate', se nostar
	matrix C = r(coefs)
	local scalars : e(scalars)
	local macros : e(macros)
	matrix Nt_full = e(Nt)
	cap matrix drop ymeanc
	cap matrix drop eymeanc
	cap matrix ymeanc = e(ymeanc)
	cap matrix eymeanc = e(eymeanc)
	foreach macro in `macros' `scalars' {
		local `macro'  "`e(`macro')'"
	}
	local rnames : rownames C
	local models : coleq C
	local models : list uniq models
	local i 0
	foreach name of local rnames {
		local ++i
		local j 0
		capture matrix drop b
		capture matrix drop se
		foreach model of local models {
			local ++j
			matrix tmp = C[`i', 2*`j'-1]
			if tmp[1,1]<. {
				matrix colnames tmp = `model'
				matrix b = nullmat(b), tmp
				matrix tmp[1,1] = C[`i', 2*`j']
				matrix se = nullmat(se), tmp
			}
		}
		
		scalar N_t = Nt_full[1,`i']
		cap scalar ymeanc_s = ymeanc[1,`i']
		cap scalar eymeanc_s = eymeanc[1,`i']
		ereturn post b
		quietly estadd matrix se
		quietly estadd scalar N_t=N_t
		quietly estadd scalar ymeanc=ymeanc_s
		quietly estadd scalar eymeanc=eymeanc_s
		foreach macro of local macros {
			cap quietly estadd local `macro' ``macro''
		}
		foreach macro of local scalars {
			quietly estadd  scalar `macro' ``macro''
		}
		eststo `estimate'_`name'
	}
end
